function X = drawsurface(V,L,r)

t = (0:pi/50:2*pi);
y = V'*r;
c = y'*L*y;
gx = (-sqrt(0.99*c/L(1,1)):0.05:sqrt(0.99*c/L(1,1)));
gy = (-sqrt(0.99*c/L(2,2)):0.05:sqrt(0.99*c/L(2,2)));
px = ones(length(gy),1)*gx; 
py = gy'*ones(1,length(gx));
z = L(1,1)*(px.*px) + L(2,2)*(py.*py);
for i=1:length(gy),
    inds = find(z(i,:)<= c);
    imin = min(inds); imax = max(inds);
    px(i,1:imin-1) = px(i,imin); z(i,1:imin-1) = c;
    px(i,imax+1:end) = px(i,imax); z(i,imax+1:end) = c;
end;    
vx = V(1,1)*px + V(1,2)*py;
vy = V(2,1)*px + V(2,2)*py;

surf(vx,vy,z);
axis equal
hold on
drawlevel(V,L,r);
drawlevel(V,L,0.75*r);
drawlevel(V,L,0.5*r);
plot(r(1),r(2),'d');
hold off