% Generate random symmetric matrices with a given condition number

frame = 0;
rand('state',0);
% Well-conditioned
L1 = [1 0; 0 2];
A1 = L1;
V1 = [1 0; 0 1];
for i=1:4,
    u = rand(2,1);
    Q = [1 0; 0 1] - 2*u*u'/(u'*u);
    A1 = Q*A1*Q';
    V1 = Q*V1;
end;

% Ill-conditioned
L2 = [1 0; 0 10];
A2 = L2;
V2 = [1 0; 0 1];
for i=1:4,
    u = rand(2,1);
    Q = [1 0; 0 1] - 2*u*u'/(u'*u);
    A2 = Q*A2*Q';
    V2 = Q*V2;
end;

x0 = V1(:,1) + 0.5*rand(2,1);
drawsurface(V1,L1,x0)
pause;


plot(0,0,'+');
hold on
plot(x0(1),x0(2),'d');
x = x0;
for i=1:4,
    drawlevel(V1,L1,x);
    title('Mthode du gradient');
    axis equal
    pause;
    r = -A1*x;
    a = (r'*r)/(r'*A1*r);
    y = x + a*r;
    plot([x(1),y(1)],[x(2),y(2)]);
    x = y;
    plot(x(1),x(2),'d');
    pause;
end;
title('A bien conditionne ==> convergence rapide');
hold off
pause;

x0 = V2(:,1)+0.3*rand(2,1);
drawsurface(V2,L2,x0)
pause;

plot(0,0,'+');
hold on
plot(x0(1),x0(2),'d');
x = x0;
for i=1:4,
    drawlevel(V2,L2,x);
    title('Mthode du gradient');
    axis equal
    pause;
    r = -A2*x;
    a = (r'*r)/(r'*A2*r);
    y = x + a*r;
    plot([x(1),y(1)],[x(2),y(2)]);
    x = y;
    plot(x(1),x(2),'d');
    pause;
end;
title('A mal conditionne ==> convergence lente');
hold off
pause

plot(0,0,'+');
title('Mthode des gradients conjugus');
hold on
plot(x0(1),x0(2),'d');
x = x0;
for i=1:2,
    drawlevel(V2,L2,x);
    axis equal
    pause;
    r = -A2*x;
    if (i==1),
        d = r;
    else
        d = r + (r'*r)/rold2*d;
    end;
    a = (r'*r)/(d'*A2*d);
    y = x + a*d;
    rold2 = r'*r;
    plot([x(1),y(1)],[x(2),y(2)]);
    x = y;
    plot(x(1),x(2),'d');
    pause;
end;

